//+------------------------------------------------------------------+
//|                                                   NeuroProba.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Blue
#property indicator_color3 Red
//---- input parameters
extern int       BeginBar=300; // rru rd  rtul udel
extern int       EndBar=201; // elu rd  rtul udel
extern int       StudyNumber=100; // eclnn rtuco ce
extern double    Betta=0.5; // edncr ncaecr ecc
extern double    StudyCoeff=0.1; // eccln lc?
extern double    MaxRandom=0.66;//2.0/MathSqrt(9);
//---- buffers
double NeuroExitBuffer[]; // uoul rlc? ldnlnc
double TeacherBuffer[]; // nrul rlc? ldnlnc (rtucl ncaru)
double ErrorBuffer[]; // nelc? r erce rdl
//---- 
double deviation; // nelcl r erce rral lc? 
double GradientFirstLay[9][9];// ? drnlnr adrclnr 1-a n?
double GradientSecondLay[9]; //  ? drnlnr adrclnr 2-a n?
double OutputFirstLay[9]; // neer uor erca ldr
double SecondSum;// neer uoa n? - rdaeln ncaecr ecc
double FirstLayWeights[9][9]; // lnr ld dlda (neduna n?)
double OutputSecondWeights[9]; // lnr uoa ldr
double InputNormalX[100][9]; // dercrr? uder ouo ncar
double InputX[9]; // nleuc o lend (ldercru)
double Normr;// der nleula oa lendr
double U_First[9];// rlc? r uol n? nedunuo (ouo) ld
double U_Second;//  rlcl r uol uoa ldr (rdaeln ncaecr ecc)
double SigmaCurr;
double Differ;
//+----------------------------------------------
//  dercrr? nrr? ec? r cnldrl (0,MaxValue), lnc rdaeln dddul - r (0,1)
//+----------------------------------------------
double NormalRand(double MaxValue=1.0)
   {
   double answer;
   answer=MathRand()/32767.0;
   answer=MaxValue*answer;
   return(answer);
   }
//+----------------------------------------------
//  dercrr? nrr? ec?
//+----------------------------------------------


//------------------------------------------
// ddlllcl ncaecr ecc  (nraln acddlclnec)
//------------------------------------------
double Sigma(double argument)
   {
   double help;
   help=(MathExp(argument)-MathExp(-argument))/(MathExp(argument)+MathExp(-argument));
   return(help);
   }
//------------------------------------------
// ddlllcl ncaecr ecc
//------------------------------------------

//------------------------------------------
// ucnlcl rdaelnr ncaecr ecc
//------------------------------------------
double GetArgument()
   {
   int j;
   double answer=0.0;
   for (j=0;j<9;j++)
      {
      answer=answer+OutputSecondWeights[j]*OutputFirstLay[j];
      }
   return(answer);
   }
//------------------------------------------
// ucnlcl rdaelnr ncaecr ecc
//------------------------------------------

//------------------------------------------
// ucnlcl uo ld dlda n?
//------------------------------------------
void GetFirstLayOutput()
   {
   int j,t;
   for (j=0;j<9;j++)
      {
      OutputFirstLay[j]=0.0;      
      for (t=0;t<9;t++)
         {
         OutputFirstLay[j]=OutputFirstLay[j]+FirstLayWeights[j,t]*InputX[t];
         }
      }
   return(0);
   }
//------------------------------------------
// ucnlcl uo ld dlda n?
//------------------------------------------

//------------------------------------------
// ucnlcl adrclnr ln ld 
//------------------------------------------
void SetGradientWeights()
   {
   int j,t;
   for (j=0;j<9;j++)
      {
      //GradientFirstLay[j,t]=0.0;
      for (t=0;t<9;t++)
         {
         GradientFirstLay[j,t]=OutputSecondWeights[j]*InputX[t]*deviation*Differ;
         //GradientFirstLay[j,t]=GradientFirstLay[j,t]+OutputSecondWeights[j]*InputX[t];
         }
      //GradientFirstLay[j,t]=GradientFirstLay[j,t]*deviation*Differ;
      GradientSecondLay[j]=OutputFirstLay[j]*deviation*Differ;
      }
   }
//------------------------------------------
// ucnlcl adrclnr ln ld 
//------------------------------------------

//------------------------------------------
// cellcl ln ld 
//------------------------------------------
void ChangeWeigts()
   {
   int i,k;
   for (i=0;i<9;i++)
      {
      for (k=0;k<9;k++)
         {
         FirstLayWeights[i,k]=FirstLayWeights[i,k]-StudyCoeff*GradientFirstLay[i,k];
         }
      OutputSecondWeights [i]=OutputSecondWeights [i]-StudyCoeff*GradientSecondLay[i];// cellcl ln uoa ldr
      } 
   }
//------------------------------------------
// cellcl ln ld
//------------------------------------------

//------------------------------------------
// u  Cdr ln ld
//------------------------------------------
void PrintWeights()
   {
   int i,k;
   for (i=0;i<9;i++)
      {
      for (k=0;k<9;k++)   
         {
//         Print("W1["+i+","+k+"]=",FirstLayWeights[i,k]);
         }
//      Print("W2["+i+"]=",OutputSecondWeights[i]);
      }
   }
//------------------------------------------
// u  Cdr ln ld
//------------------------------------------

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,NeuroExitBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,TeacherBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ErrorBuffer);
   SetIndexLabel(0,"Answer");
   SetIndexLabel(1,"Teacher");
   SetIndexLabel(2,"Error");
   ArrayInitialize(NeuroExitBuffer,0.0);      
   ArrayInitialize(TeacherBuffer,0.0);      
   ArrayInitialize(ErrorBuffer,0.0); 
//------------------------------------------
// rdlcl udec ouo ncar
//------------------------------------------
   int i,k,m,n,p; // m - clen ln uoa ldr, p - nlnce cer lc?
   for (i=BeginBar;i>=EndBar;i--)
      {
      Normr=0.0;
      for (k=0;k<=8;k++)
         {InputX[k]=Close[i]-Close[i+k+1];
         Normr=Normr+InputX[k]*InputX[k];
         }
      Normr=MathSqrt(Normr);   
      for (k=0;k<=8;k++)
         {      
         InputNormalX[BeginBar-i,k]=InputX[k]/Normr;
         TeacherBuffer[BeginBar-i]=0.0;
         if (iCustom(NULL,0,"Kaufman2",1,i)>0) TeacherBuffer[BeginBar-i]=1;
         if (iCustom(NULL,0,"Kaufman2",2,i)>0) TeacherBuffer[BeginBar-i]=-1;
      //TeacherBuffer[BeginBar-i]=iCustom(NULL,0,"KaufmanTrend",0,BeginBar);      
         }
       }
//------------------------------------------
// rdlcl udec ouo ncar
//------------------------------------------
   MathSrand(LocalTime());
//------------------------------------------
// rdlcl ln ld nruec lccrec
//------------------------------------------
   for (i=0;i<9;i++)
      {
      for (k=0;k<9;k++)
         {
         FirstLayWeights[i,k]=NormalRand(MaxRandom);
//         Print("FirstLayWeights["+i+","+k+"]=",FirstLayWeights[i,k]);
         }
      OutputSecondWeights[i]=NormalRand(MaxRandom);
      }
//------------------------------------------
// rdlcl ln ld nruec lccrec
//------------------------------------------
   PrintWeights();
//   Print("Sigma=",Sigma(NormalRand()));
   Print("Cccrcrc? relr");

//------------------------------------------
// lcl
//------------------------------------------
for (p=1;p<=StudyNumber;p++) // ce lc? - p-eld lc?
   {
   for (n=0;n<100;n++) // ddo d udel ouo ncar -  n-eld rtula ncarr
      {
      for (int z=0;z<9;z++) InputX[z]=InputNormalX[n,z]; // rdce o lend c ernncr danluo dercruo lend
      GetFirstLayOutput();
      U_Second=GetArgument();
      Print("p=",p," n=",n," U_Second=",U_Second);
      PrintWeights();
      SigmaCurr=Sigma(Betta*U_Second);
      Differ=Betta*(1-SigmaCurr*SigmaCurr); // ddcr? n nralnr acdldclnea
      deviation=TeacherBuffer[BeginBar-n]-SigmaCurr; //rcer dlr, nldld r deddlencdrn lnr
      SetGradientWeights();
      ChangeWeigts();
      }// ddo d udel ouo ncar   
   }// ce lc?
//------------------------------------------
// lcl
//------------------------------------------
   PrintWeights();
   Comment("lcl rel");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,m;
   int counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   int limit;
   //limit=Bars-10-counted_bars;
   limit=300;
   for (i=limit;i>=0;i--) 
      {
      if (iCustom(NULL,0,"Kaufman2",1,i)>0) TeacherBuffer[i]=1;
      if (iCustom(NULL,0,"Kaufman2",2,i)>0) TeacherBuffer[i]=-1;
      Normr=0.0;
      for (m=0;m<9;m++)
         {
         InputX[m]=Close[i]-Close[i+m+1];
         Normr=Normr+InputX[m]*InputX[m];
         }
      Normr=MathSqrt(Normr);
      Print("Normr=",Normr);
      for (m=0;m<9;m++)
         {
         InputX[m]=InputX[m]/Normr;
         }
      GetFirstLayOutput();
      U_Second=GetArgument();
      Print("U_Second=",U_Second);
      NeuroExitBuffer[i]=Sigma(Betta*U_Second);
      //Print("NeuroExitBuffer["+i+"]=",NeuroExitBuffer[i]);
      ErrorBuffer[i]=TeacherBuffer[i]-NeuroExitBuffer[i];
      }
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+